use strict;
use warnings;

if(@ARGV!=1)
{
        warn "Usage: <*.snp>\n";
        exit 1;
}

my $m_t;
my $f_t;
my %dup;
my $err=0;
my $M=0;
my $nonM=0;
my $N=0;
my $Ni=0;
while(<>)
{
        chomp;
        #chr9   18451921        CC,CC,A/C       CC      he      9-18451901-18451941,9-18451914-18451969,        rs_id
        my @F=split;

		my ($ma_nt, $fe_nt, $allele_anno)=split /,/, $F[2];
		my ($ma_a1, $ma_a2)=split //, $ma_nt;
		my ($fe_a1, $fe_a2)=split //, $fe_nt;
		my ($A, $B)=split /\//, $allele_anno;        
        next if $F[0]=~/X|Y|M/;
                
        if($ma_a1 eq $ma_a2)
        {
                $N++;
                my $specific=$ma_a1 eq $A ? $B : $A;
                my @bases=split //, $F[3];
                my @pos=split /,/, $F[5];
                while(my $b=shift @bases)
                {
                        my $p=shift @pos;
                        if(exists $dup{$p})
                        {
                                next;
                        }
                        $dup{$p}=1;
                        my ($chr, $start, $end)=split /-/, $p;
                        my $len=$end-$start+1;
                        if($b eq $ma_a1)
                        {
                                $M++;
                        }
                        elsif($b eq $specific)
                        {
                                $nonM++;
                        }
                }
        }
}


my $Bfrac=$nonM/($M+$nonM)*100;

print join("\t", $M, $nonM, $Bfrac), "\n";
