#!/usr/bin/perl

use strict;
use warnings;

if( $#ARGV < 0 )
{
	print STDERR "\nUsage: perl $0 <prefix.Bfrac> <linear_parameters.dat>\n";
	print STDERR "\nThis program is designed to calculate fetal DNA fraction\n\n";
	exit 1;
}

open IN, "$ARGV[1]" or die( "$!" );
chomp(my $slope=<IN>);
chomp(my $intercept=<IN>);  
close IN;

open IN, "$ARGV[0]" or die( "$!" );
chomp(my $dat=<IN>);
my @dat=split("\t",$dat);
my $B=$dat[-1];
close IN;

my $F=$slope*$B+$intercept;
print $F,"\n";


