### R script to deduce parameters for linear regression model

argv = commandArgs(T);
if( length(argv) != 1 )
{
print( 'usage: R --slave --args <example/training_dataset.dat> < linearRegression.R' );
q();
}

dat=argv[1];

# data input
train=read.table(dat);

# perform linear regression
m=lm(train$V2~train$V1);
sm=summary(m);

# get slope and intercept for linear model
P=c(sm$coefficients[2],sm$coefficients[1])

# write parameters
write.table(P,file="linear_parameters.dat",quote = FALSE,row.names = FALSE, col.names = FALSE)
