#!/usr/bin/perl
use strict;
use warnings;

if(@ARGV<3)
{
	print "usage: $0 <mis_num> <hit_num> <soap2_result> >out 2>log\n";
	exit 1;
}
my $mismatch_allow=shift;
my $hit_counts=shift;


my $insert_size_max=1000;
my $insert_size_min=0;
my %chr_readCounts;
my $flt_count=0;
my $tot;
while(<>)
{
	chomp; 
	my ($idA, $seqA, $quaA, $hitsA, $end_flagA, $lenA, $strandA, $chrA, $locationA, $mismatchA, @remainA)=split;
	chomp(my $next_line=<>);
	my ($idB, $seqB, $quaB, $hitsB, $end_flagB, $lenB, $strandB, $chrB, $locationB, $mismatchB, @remainB)=split /\s+/, $next_line;
	$tot++;
	if($strandA eq '+' && $strandB eq '-' && $locationA > $locationB)
	{
		$flt_count++;
		next;
	}
	if($strandA eq '-' && $strandB eq '+' && $locationA < $locationB)
	{
		$flt_count++;
		next;
	}
	
	my $chr=$chrA;
	my ($chr_id)=$chr=~/chr(\S+)/;
	next unless (defined $chr_id);
	my $startA=$locationA-1;
	my $startB=$locationB-1;
	my $endA=$locationA+$lenA-1;
	my $endB=$locationB+$lenB-1; 
	if($strandA ne $strandB && $chrA eq $chrB)
	{ 
		my $start=$startA<$startB ? $startA : $startB;
		my $end=$endA>$endB ? $endA : $endB;
		my $insert_size=$end-$start;
		next if($insert_size>$insert_size_max||$insert_size<$insert_size_min);
		
		my $db_start_location=$start+1;
		my $chr_start_end="$chr_id\-$db_start_location\-$end";
		if($hitsA<=$hit_counts && $mismatchA<=$mismatch_allow && $hitsB<=$hit_counts && $mismatchB<=$mismatch_allow)
		{
		  print  join("\t", $chrA, $locationA-1, $locationA+$lenA-1,"$seqA:$quaA:$hitsA:$mismatchA:0:$chr_start_end", 1, $strandA),"\n";
		  print  join("\t", $chrB, $locationB-1, $locationB+$lenB-1,"$seqB:$quaB:$hitsB:$mismatchB:0:$chr_start_end", 1, $strandB),"\n";
		  $chr_readCounts{$chr}+=2;
		}				
	}
	else
	{
		warn "the reads not paired!\n";
	}	
}


for(1..22, 'X', 'Y', "M")
{
	my $chr="chr$_";
	if(exists $chr_readCounts{$chr})
	{
		warn "$chr\t$chr_readCounts{$chr}\n";
	}
}

warn "Tot: $tot\tFlt: $flt_count\n";
